// 56_1.cpp:   .

#include "stdafx.h"
#include <clocale>     //   setlocale()

#include <stdio.h>     //for getchar(),putchar()
#include <conio.h> 
#include <string.h> 

using namespace System;

#define MAXLINE 1000 
#define eof -1        //Ctrl+z
 
// ---     ---
int getline(char s[], int lim)
{
	int c,i;
	for(i=0; i<lim-1 && (c=getchar()) != eof && c != '\n'; i++)
		s[i]=c;
	s[i]='\0';
	i++;    //   
	return i;
}

// ---  t[]  s[] ---
void strcpy1 (char s[],char t[]) 
{
	int i=0; 
	while((s[i]=t[i])!='\0')
		i++;
}

// ---  ,     t, 
//  ,     s ---
void strcpy2 (char *s, char *t)
{
	while((*s=*t) != '\0')
	{
		s++;
		t++;
	}
}

// ---    new()    ,    s, 
//       ,       
//    . ---
char *strsave(char *s)
{
	char *p;
	int i = strlen(s) + 1; 
	p =  new char [i]; //   
	if((p != NULL))
		strcpy2(p,s);  //   
	return p ;  //   ,   
}

void main()
{
	setlocale(LC_ALL,"Russian"); // setlocale()  
	                             //   

	// strcpy1()
	printf("   strcpy1 >");
	char s[MAXLINE],t[MAXLINE];
	getline(t,MAXLINE); //     t
	strcpy1(s,t);
	printf("  = %s\n  = %s\n",t,s);
	// strcpy2()
	printf("   strcpy2 >");
	getline(t,MAXLINE);   //      t
	strcpy2(&s[0],&t[0]);
	printf("  = %s\n  = %s\n",t,s);
	// strsave()
	printf("   strsave >");
	getline(s,MAXLINE);   //   s
	char *p = strsave(&s[0]); //     ,     s
	printf("  = %s\n", p);
	delete [] p; //   
	_getch();
}
